<?php
	require_once('../../../phplibs/castiron.inc.php');
	require_once(CI_PATH_LIBS.'/session.inc.php');
	require_once(CI_PATH_LIBS.'/addressbook.inc.php');

	$headers=array(
		'destination', 'name', 'surname', 'company', 'email', 'mobile', 'office',
		'extension', 'home', 'url', 'shortcut', 'user_id', 'group_id'
	);

	if ($_REQUEST['fields_enclosure'] == 'singlequote')	$_REQUEST['fields_enclosure']="'";
	if ($_REQUEST['fields_enclosure'] == 'doublequote')	$_REQUEST['fields_enclosure']='"';
	if ($_REQUEST['fields_delimiter'] == 'TAB')			$_REQUEST['fields_delimiter']="\t";

	$count=0;
	$overwrites=0;
	$new=0;
	$error=false;

	$CI_DB->query('BEGIN');
	if ($_FILES['archive']['size'] && is_uploaded_file($_FILES['archive']['tmp_name']))
	{
		if ($_REQUEST['delete_addressbook'] == 'true') $CI_DB->query("delete from addressbook");
		
		$fp=fopen($_FILES['archive']['tmp_name'], 'r');
		while ($values=fgetcsv($fp, null, $_REQUEST['fields_delimiter'], $_REQUEST['fields_enclosure']))
		{
			$count++;
			if (($_REQUEST['skip_first_line'] == 'true') && ($count == 1)) continue;

			if (sizeof($values) != sizeof($headers))
			{
				$error=true;
				break;
			}

			$fields=array();
			for ($i=0; $i<sizeof($headers); $i++) $fields[$headers[$i]]=$values[$i];

			if (!$fields['user_id'])
			{
				$fields['user_id']=null;
				$where_user_id='user_id is null';
			}
			else
			{
				$where_user_id="user_id=".$CI_DB->quoteSmart($fields['user_id']);
			}
			
			if (!$fields['group_id'])
			{
				$fields['group_id']=null;
				$where_group_id='group_id is null';
			}
			else
			{
				$where_group_id="group_id=".$CI_DB->quoteSmart($fields['group_id']);
			}

			$row=$CI_DB->getOne("select shortcut from addressbook where $where_user_id and $where_group_id");
			if ($row && ($_REQUEST['overwrite_existing'] == 'true'))
			{
				$CI_DB->query("delete from addressbook where shortcut=".$CI_DB->quoteSmart($fields['shortcut'])." and $where_user_id and $where_group_id");
				$res=$CI_DB->autoExecute('addressbook', $fields, DB_AUTOQUERY_INSERT);
				$overwrites++;
			}
			elseif (!$row)
			{
				$res=$CI_DB->autoExecute('addressbook', $fields, DB_AUTOQUERY_INSERT);
				$new++;
			}
		}
		fclose($fp);
	}
	$CI_DB->query($error ? 'ROLLBACK' : 'COMMIT');

	if (is_uploaded_file($_FILES['archive']['tmp_name'])) unlink($_FILES['archive']['tmp_name']);

	header('Location:/index.php?url='.urlencode('addressbook/import/report.php?error='.($error ? 1 : 0).'&count='.$count.'&overwrites='.$overwrites.'&new='.$new));
	exit;
?>