#!/usr/bin/env python

# Copyright and license: Please refer to LICENSE.TXT

import sys
import os
import os.path

_selfpath=(os.path.dirname(os.path.realpath(__file__)).split('/'))[:-1]
_selfpath.append('pylibs')
_libspath='/'.join(_selfpath)
sys.path.append(_libspath)

from s2p import *

sys.path.append(CORE_PATH_SDK+'/python')

from s2p_base import *

S2P_CONF_SYSTEM	= xml_to_array(CORE_PATH_CONFIG+'/system.xml')
S2P_CONF_SKYPE	= xml_to_array(CORE_PATH_CONFIG+'/skype.xml', 0)

if S2P_CONF_SKYPE.has_key('item'):
	for item in S2P_CONF_SKYPE['item'].values():
		name=item['+']['skype'][0]['+']['username'][0]['#']

		if not item['+'].has_key('enabled') or item['+']['enabled'][0]['#'] != "true": continue
		print name